import { CircleGeometry } from 'three';
import Geometry from './Geometry.js';

export default {
  extends: Geometry,
  props: {
    radius: { type: Number, default: 1 },
    segments: { type: Number, default: 8 },
    thetaStart: { type: Number, default: 0 },
    thetaLength: { type: Number, default: Math.PI * 2 },
  },
  methods: {
    createGeometry() {
      this.geometry = new CircleGeometry(this.radius, this.segments, this.thetaStart, this.thetaLength);
    },
  },
};
